#include "Type.hpp"

/*=================================================================
new deletẽTCYv
=================================================================*/

// RXgN^
type::mem_base::mem_base() {}

namespace global {
    // mۗʂv
    static unsigned long long allocated_size;
    static type::deque<long> size;
} // end namespace global

void *type::mem_base::operator new(size_t t){
      #if defined(_DEBUG_MODE)
        global::allocated_size += t;
        global::size.push_front(t);
      #endif
      void *p = malloc(t);
      if( ! p) { 
        puts("failed memory allocate"); 
        exit(EXIT_FAILURE);
      }
      return p;
 }

void *type::mem_base::operator new[](size_t t) {
      #if defined(_DEBUG_MODE)
        global::allocated_size += t;
        global::size.push_front(t);
      #endif
      void *p = malloc(t);
      if( ! p) { 
        puts("failed memory allocate"); 
        exit(EXIT_FAILURE);
      }
      return p;
}

void type::mem_base::operator delete(void *p) {
      #if defined(_DEBUG_MODE)
        global::allocated_size -= global::size[0];
        global::size.pop_front();
      #endif
      free(p);
} 

void type::mem_base::operator delete[](void *p) {
      #if defined(_DEBUG_MODE)
        global::allocated_size -= global::size[0];        
        global::size.pop_front();
      #endif
      free(p);
}

const unsigned long long &type::current_memory() { return global::allocated_size; }